unit U_YSCR;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxGraphics, cxCustomData, cxStyles, cxTL, cxMaskEdit, DB, ADODB,
  cxInplaceContainer, cxDBTL, cxControls, cxTLData, ComCtrls, ToolWin,
  StdCtrls, cxFilter, cxData, cxDataStorage, cxEdit, cxDBData, DBClient,
  cxGridCustomTableView, cxGridTableView, cxGridDBTableView, ExtCtrls,
  cxSplitter, cxGridLevel, cxClasses, cxGridCustomView, cxGrid,
  cxGridCustomPopupMenu, cxGridPopupMenu, RM_Dataset, RM_System, RM_Common,
  RM_Class, RM_GridReport, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdFTP,ShellAPI,IniFiles, cxCheckBox, cxCalendar,
  cxButtonEdit, cxTextEdit, cxPC, cxDropDownEdit, cxCurrencyEdit, Menus;

type
  TfrmYSCR = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBDel: TToolButton;
    TBClose: TToolButton;
    ADOQueryTemp: TADOQuery;
    ADOQueryCmd: TADOQuery;
    Panel1: TPanel;
    ToolButton2: TToolButton;
    Label1: TLabel;
    YFName: TEdit;
    ADOQueryMain: TADOQuery;
    ToolButton1: TToolButton;
    RM1: TRMGridReport;
    RMDB_Main: TRMDBDataSet;
    Label3: TLabel;
    FactoryName: TEdit;
    cxGrid2: TcxGrid;
    Tv2: TcxGridDBTableView;
    cxGridDBColumn1: TcxGridDBColumn;
    cxGridDBColumn3: TcxGridDBColumn;
    cxGridDBColumn5: TcxGridDBColumn;
    cxGridDBColumn6: TcxGridDBColumn;
    cxGridLevel1: TcxGridLevel;
    Label6: TLabel;
    begdate: TDateTimePicker;
    Enddate: TDateTimePicker;
    cxGridPopupMenu2: TcxGridPopupMenu;
    DS_HZ: TDataSource;
    CDS_HZ: TClientDataSet;
    ToolButton3: TToolButton;
    v2Column1: TcxGridDBColumn;
    VBZ: TcxGridDBColumn;
    VUSDMoney: TcxGridDBColumn;
    VRMBMoney: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    VMOrderNo: TcxGridDBColumn;
    v2PS: TcxGridDBColumn;
    v2Column2: TcxGridDBColumn;
    v2KP: TcxGridDBColumn;
    v2MP_CodeName: TcxGridDBColumn;
    v2Column4: TcxGridDBColumn;
    v2Column5: TcxGridDBColumn;
    MP_CodeName: TEdit;
    Label4: TLabel;
    MP_Spec: TEdit;
    Label5: TLabel;
    Label7: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    CheckBox1: TCheckBox;
    MOrderNo: TEdit;
    Label8: TLabel;
    Tchk: TToolButton;
    Tnochk: TToolButton;
    cxTabControl1: TcxTabControl;
    v2ComTaitou: TcxGridDBColumn;
    TZDSC: TToolButton;
    v2MaoQty: TcxGridDBColumn;
    v2JZQty: TcxGridDBColumn;
    v2ConNoHZ: TcxGridDBColumn;
    v2PRTColor: TcxGridDBColumn;
    Label9: TLabel;
    PRTColor: TEdit;
    v2PBNote: TcxGridDBColumn;
    v2MQty: TcxGridDBColumn;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    v2FeeType: TcxGridDBColumn;
    Label14: TLabel;
    ConNoHZ: TEdit;
    v2chkstatus: TcxGridDBColumn;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    v2KPType: TcxGridDBColumn;
    cxStyleRepository1: TcxStyleRepository;
    cxStyle1: TcxStyle;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    KPType: TComboBox;
    BZType: TComboBox;
    Chkstatus: TComboBox;
    v2Column3: TcxGridDBColumn;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    MainMenu1: TMainMenu;
    cxSplitter1: TcxSplitter;
    cxGrid1: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1ConNo: TcxGridDBColumn;
    v1PRTOrderQty: TcxGridDBColumn;
    v1OrderUnit: TcxGridDBColumn;
    v1DDTPPS: TcxGridDBColumn;
    v1DDTPQty: TcxGridDBColumn;
    v1PBCKDate: TcxGridDBColumn;
    v1DJCKPS: TcxGridDBColumn;
    v1DJCKQty: TcxGridDBColumn;
    v1PBSH: TcxGridDBColumn;
    v1HCDate: TcxGridDBColumn;
    v1sumJYPS: TcxGridDBColumn;
    v1sumJYQty: TcxGridDBColumn;
    v1JYDate: TcxGridDBColumn;
    v1JYSH: TcxGridDBColumn;
    v1CKDate: TcxGridDBColumn;
    v1SumCKPS: TcxGridDBColumn;
    v1SumCKQty: TcxGridDBColumn;
    v1CPKC: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    cxGridPopupMenu1: TcxGridPopupMenu;
    DataSource1: TDataSource;
    CDS_Main: TClientDataSet;
    Panel2: TPanel;
    v1sumJYCPQty: TcxGridDBColumn;
    v1sumJYCPPS: TcxGridDBColumn;
    v2KPNO: TcxGridDBColumn;
    Label22: TLabel;
    KPNO: TEdit;
    v1JYZPS: TcxGridDBColumn;
    v1JYZQty: TcxGridDBColumn;
    cxStyle2: TcxStyle;
    v1SOrdDefStr4: TcxGridDBColumn;
    v1PRTColor: TcxGridDBColumn;
    v2SJFHDate: TcxGridDBColumn;
    ComboBox1: TComboBox;
    v2filler: TcxGridDBColumn;
    v1SumHXCKPS: TcxGridDBColumn;
    v1SumHXCKQty: TcxGridDBColumn;
    v2KPStatusH: TcxGridDBColumn;
    Label2: TLabel;
    KPStatusH: TComboBox;
    Label23: TLabel;
    Note: TEdit;
    v1KGQty: TcxGridDBColumn;
    cxStyle3: TcxStyle;
    ToolButton6: TToolButton;
    v2Column7: TcxGridDBColumn;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBCloseClick(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure FactoryNameChange(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure cxGridDBColumn8PropertiesEditValueChanged(Sender: TObject);
    procedure cxGridDBColumn5PropertiesEditValueChanged(Sender: TObject);
    procedure cxGridDBColumn1PropertiesEditValueChanged(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure cxGridDBColumn3PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure cxGridDBColumn6PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v2Column3PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure ToolButton1Click(Sender: TObject);
    procedure v2Column7PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v2PSPropertiesEditValueChanged(Sender: TObject);
    procedure v2Column2PropertiesEditValueChanged(Sender: TObject);
    procedure v2KPMoneyPropertiesEditValueChanged(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure cxTabControl1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TchkClick(Sender: TObject);
    procedure TnochkClick(Sender: TObject);
    procedure v2ComTaitouPropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure TZDSCClick(Sender: TObject);
    procedure VBZPropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v2Column4PropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure v2Column5PropertiesChange(Sender: TObject);
    procedure v2ConNoHZPropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
    procedure Tv2StylesGetContentStyle(Sender: TcxCustomGridTableView;
      ARecord: TcxCustomGridRecord; AItem: TcxCustomGridTableItem;
      out AStyle: TcxStyle);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure v2KPTypePropertiesEditValueChanged(Sender: TObject);
    procedure VYBPropertiesEditValueChanged(Sender: TObject);
    procedure VRMBMoneyPropertiesEditValueChanged(Sender: TObject);
    procedure Tv2CellDblClick(Sender: TcxCustomGridTableView;
      ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton;
      AShift: TShiftState; var AHandled: Boolean);
    procedure Tv2CellClick(Sender: TcxCustomGridTableView;
      ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton;
      AShift: TShiftState; var AHandled: Boolean);
    procedure v2KPNOPropertiesEditValueChanged(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure v2PRTColorPropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
  private
    { Private declarations }

    procedure InitGridHZ();
    procedure InitGrid();
    function  SaveData():Boolean;
    procedure SetStatus();
  public
    fflag:integer;
    { Public declarations }
    RKFlag,FCYID,canshu2,canshu1:String;
    fmanage:string;
  end;
var
  frmYSCR: TfrmYSCR;

implementation
uses
  U_DataLink,U_Fun,U_ZDYHelp, U_ProductOrderNewList, U_ProductOrderList,
  U_ZdyAttachment, U_SXCKNewList, U_SXCKNewList_SK,U_JYOrderCon_CX,U_DJBCKKCList_DDSH,U_CPXSCKList;

{$R *.dfm}
procedure TfrmYSCR.SetStatus();
var i:integer;
begin
  Tchk.Enabled:=false;
  TNochk.Enabled:=false;
  for i:=0 to tv2.ColumnCount-1 do
  begin
    IF uppercase(tv2.Columns[i].DataBinding.FieldName)<>'SSEL' then
    tv2.Columns[i].Options.Editing:=false;
  end;
    if cxTabControl1.TabIndex=0 then
    begin
      Tchk.Enabled:=true;
      for i:=0 to tv2.ColumnCount-1 do
      begin
        tv2.Columns[i].Options.Editing:=true;
      end;
    end;
    if cxTabControl1.TabIndex=1 then
    begin
      TNochk.Enabled:=true;
    end;
    if cxTabControl1.TabIndex=2 then
    begin
    end;
  v2KPType.Options.Editing:=true;
  v2ComTaitou.Options.Editing:=true;
end;

procedure TfrmYSCR.InitGrid();
begin
  begdate.SetFocus;
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered:=False;
      Close;
      SQL.Clear;
     sql.Add('select isnull(A.P_CodeName,E.PrtCodeName) MP_CodeName,');
      sql.add('RMBMoney=(case when (A.BZType<>''$'') and (A.BZType<>''USD'') then Money else 0 end)');
      sql.add(',USDMoney=(case when (A.BZType<>''￥'') and (A.BZType<>''RMB'') then Money else 0 end)');
      sql.add(',ConNoHZ=isnull(F.ConNo,A.ConNO),isnull(isnull(E.prtspec,A.P_Spec),D.MPRTSpec) MP_Spec,');
      sql.add('isnull(A.OrderNo,D.OrderNo) MOrderNo,KPStatusH=(case when isnull(KPstatus,'''')='''' then ''未开票'' else ''开票完成'' end),');
      //调用指示单颜色
//      sql.add('E.PRTColor,E.SOrdDefStr4,');   
      sql.add('isnull(A.P_Color,G.PRTColor) PRTColor,E.SOrdDefStr4,');
      SQL.ADD(' KPStatusH=(case when isnull(KPstatus,'''')='''' then ''未开票'' else ''开票完成'' end),');
      sql.add('HTType=(isnull((select Top 1 M.MPRTType from JYOrder_ConORD Q ');
      sql.add(' inner join JYOrderCon_Main M on Q.ConMainid=M.Mainid where Q.Mainid=A.Mainid),F.MPRTType))');
      //匹配合同单价
      sql.add(',E.PrtPrice,A.*');
      sql.Add(' from YF_Money_CR A');
      sql.add(' left join JYOrder_Main D on D.Mainid=A.Mainid ');
      //连接生产指示单明细
      SQL.Add(' left join JYOrder_Sub G on G.Subid=A.Subid');
      //绑定合同明细
      //sql.add(' left join JYOrderCon_Sub E on E.Subid=A.Conid');
      sql.add(' left join JYOrderCon_Sub E on E.PrtCodeName=D.MPrtCodeName and E.PRTMF=D.MPRTMF and E.PRTKZ=D.MPRTKZ and E.PRTColor=G.PRTColor');
      SQL.ADD(' Left join JYOrderCon_Main F on F.Mainid=E.Mainid');
      sql.Add(' where 1=1');
      if ComboBox1.Text='发货日期' then
      begin
        sql.Add(' and A.SJFHDate>='''+FormatDateTime('yyyy-MM-dd',begdate.DateTime)+''' ');
        sql.Add(' and A.SJFHDate<'''+FormatDateTime('yyyy-MM-dd',Enddate.DateTime+1)+''' ');
      end
      else
      begin
        sql.Add(' and A.CRTime>='''+FormatDateTime('yyyy-MM-dd',begdate.DateTime)+''' ');
        sql.Add(' and A.CRTime<'''+FormatDateTime('yyyy-MM-dd',Enddate.DateTime+1)+''' ');
      end;
      sql.Add(' and A.CRType=''应收款登记'' ');
      sql.add(' and (A.YFName=''成品销售金额'' or Isnull(A.FeeType,'''')=''其他费用'')');
      IF cxTabControl1.TabIndex=0 then
      sql.Add(' and A.status=''0'' ');
      IF cxTabControl1.TabIndex=1 then
      sql.Add(' and A.status=''1'' ');
      IF cxTabControl1.TabIndex=2 then
      sql.Add(' and A.status=''2'' ');
      if trim(fmanage)<>'高权限' then
      begin
        sql.add(' and (A.filler='''+trim(DName)+''' or F.ConPerson1='''+trim(DName)+''' or D.YWY='''+trim(Dname)+''' or F.KeFu='''+trim(DName)+''' or D.Filler='''+Trim(Dname)+''' ');
        sql.add(' or exists (select B.Chker from OrdCon_Chk B where B.Mainid=F.Mainid and B.Chker='''+trim(DName)+'''))');
      end;
      sql.add(' order by A.CRTime,F.ConNo,E.XHNO');
      Open;
    end;
    SCreateCDS20(ADOQueryMain,CDS_HZ);
    SInitCDSData20(ADOQueryMain,CDS_HZ);
    Label12.Caption:='0';
    Label13.Caption:='0';
    Label19.Caption:='0';
    Label21.Caption:='0';
  finally;
    ADOQueryMain.EnableControls;
    //ToolButton2.Click;
  end;
end;

procedure TfrmYSCR.InitGridHZ();
begin

end;

procedure TfrmYSCR.FormDestroy(Sender: TObject);
begin
  frmYSCR:=nil;
end;

procedure TfrmYSCR.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TfrmYSCR.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('应收款登记1',Tv2,'财务管理');
  {with ADOQueryCmd do
  begin
    Close;
    SQL.Clear;
    sql.Add('delete CK_YP_CR where isnull(CRTime,'''')='''' and CYID='''+Trim(FCYID)+''' and CRType='''+Trim(RKFlag)+'''');
    ExecSQL;
  end;}
  Close;
end;
procedure TfrmYSCR.TBDelClick(Sender: TObject);
var
  FBBMoney,CRID:string;
begin
  if CDS_HZ.IsEmpty then Exit;
  if cxtabcontrol1.TabIndex<>0 then exit;
  if CDS_HZ.Locate('ssel',true,[])=false then
  begin
    Application.MessageBox('没有选择数据!','提示',0);
    Exit;
  end;
  if Application.MessageBox('确定要删除数据吗？','提示',32+4)<>IDYES then Exit;
  try
    ADOQueryCmd.Connection.BeginTrans;
    with CDS_HZ do
    begin
      DisableControls;
      First;
      while not eof do
      begin
        IF Fieldbyname('ssel').AsBoolean=true then
        begin
          {if Trim(CDS_HZ.fieldbyname('YFType').AsString)<>'' then
          begin
            Application.MessageBox('自动生成数据不能删除!','提示',0);
            Exit;
          end;}
          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('delete YF_Money_CR where YFID='''+Trim(CDS_HZ.fieldbyname('YFID').AsString)+'''');
            execsql;
          end;
        end;
        next;
      end;
      First;
      EnableControls;
    end;
    InitGrid();
    ADOQueryCmd.Connection.CommitTrans;
  except
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox('操作失败！','提示信息',0);
  end;
end;

procedure TfrmYSCR.FormShow(Sender: TObject);
begin
  ReadCxGrid('应收款登记1',Tv2,'财务管理');
  Enddate.DateTime:=SGetServerDate(ADOQueryTemp);
  begdate.DateTime:=SGetServerDate(ADOQueryTemp)-7;
  //v2KPType.Visible:=False;
  SetStatus();
  InitGrid();
end;

procedure TfrmYSCR.TBRafreshClick(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmYSCR.ToolButton2Click(Sender: TObject);
begin
  Label12.Caption:='0';
  Label13.Caption:='0';
  Label19.Caption:='0';
  Label21.Caption:='0';
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain,SGetFilters(Panel1,1,2));
    SCreateCDS20(ADOQueryMain,CDS_HZ);
    SInitCDSData20(ADOQueryMain,CDS_HZ);
  end;
end;

procedure TfrmYSCR.FactoryNameChange(Sender: TObject);
begin
  ToolButton2.Click;
end;

procedure TfrmYSCR.Button2Click(Sender: TObject);
begin
  if CDS_HZ.IsEmpty then Exit;
  if Application.MessageBox('确定要删除数据吗？','提示',32+4)<>IDYES then Exit;
  if Trim(CDS_HZ.fieldbyname('SubID').AsString)<>'' then
  begin
    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('delete YCL_SG_HZ where SubID='''+Trim(CDS_HZ.fieldbyname('SubID').AsString)+'''');
      ExecSQL;
    end;
  end;
  CDS_HZ.Delete;
end;

function TfrmYSCR.SaveData():Boolean;
var
  maxId,CRID:String;
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    if GetLSNo(ADOQueryCmd,maxId,'YS','YF_Money_CR',4,1)=False then
    begin
      Result:=False;
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('取最大号失败！','提示',0);
      Exit;
    end;
    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('select * from YF_Money_KC where FactoryName='''+Trim(CDS_HZ.fieldbyname('FactoryName').AsString)+'''');
      Open;
    end;
    if ADOQueryCmd.IsEmpty=False then
    begin
      CRID:=ADOQueryCmd.fieldbyname('CRID').AsString;
    end else
    begin
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add('Update YF_Money_CRID set CRID=CRID+1');
        sql.Add('select * from YF_Money_CRID ');
        Open;
      end;
      CRID:=ADOQueryCmd.fieldbyname('CRID').AsString;
      with ADOQueryCmd do
      begin
        Close;
        SQL.Clear;
        sql.Add('select * from YF_Money_KC where 1<>1');
        Open;
      end;
      with ADOQueryCmd do
      begin
        Append;
        FieldByName('CRID').Value:=StrToInt(CRID);
        FieldByName('FactoryNo').Value:=Trim(CDS_HZ.fieldbyname('FactoryNo').AsString);
        FieldByName('FactoryName').Value:=Trim(CDS_HZ.fieldbyname('FactoryName').AsString);
        FieldByName('ZdyStr1').Value:='应收收';
        Post;
      end;
    end;
    with ADOQueryCmd do
    begin
      Close;
      SQL.Clear;
      sql.Add('select * from YF_Money_CR where 1=2');
      Open;
    end;
    with ADOQueryCmd do
    begin
      Append;
      FieldByName('YFID').Value:=Trim(maxId);
      FieldByName('CRID').Value:=StrToInt(CRID);
      //SSetSaveDataCDSNew(ADOQueryCmd,Tv2,CDS_HZ,'YF_Money_CR',3);
      FieldByName('Filler').Value:=Trim(DName);
      FieldByName('CRType').Value:='应收款登记';
      FieldByName('CRFlag').Value:='应收收';
      FieldByName('QtyFlag').Value:=1;
      FieldByName('ConID').Value:=Trim(CDS_HZ.fieldbyname('ConID').AsString);
      FieldByName('ConNo').Value:=Trim(CDS_HZ.fieldbyname('ConNoHZ').AsString);
      FieldByName('Price').Value:=CDS_HZ.fieldbyname('Price').asfloat;
      FieldByName('P_CodeName').Value:=Trim(CDS_HZ.fieldbyname('MP_CodeName').AsString);
      FieldByName('P_SPec').Value:=Trim(CDS_HZ.fieldbyname('MP_SPec').AsString);
      fieldbyname('ComTaitou').Value:=Trim(CDS_HZ.fieldbyname('ComTaitou').AsString);
      fieldbyname('BZType').Value:=Trim(CDS_HZ.fieldbyname('BZType').AsString);

      FieldByName('FactoryNo').Value:=Trim(CDS_HZ.fieldbyname('FactoryNo').AsString);
      FieldByName('FactoryName').Value:=Trim(CDS_HZ.fieldbyname('FactoryName').AsString);
      FieldByName('YFName').Value:=Trim(CDS_HZ.fieldbyname('YFName').AsString);
      FieldByName('FeeType').Value:=Trim(CDS_HZ.fieldbyname('FeeType').AsString);
      FieldByName('CRTime').Value:=SGetServerDate(ADOQueryTemp);
      FieldByName('YFDefFlag1').Value:=fFlag;
      FieldByName('status').Value:='0';
      Post;
    end;
    with CDS_HZ do
    begin
      Edit;
      FieldByName('YFId').Value:=Trim(maxId);
      FieldByName('CRID').Value:=StrToInt(CRID);
    end;
    ADOQueryCmd.Connection.CommitTrans;
    Result:=True;
  except
    Result:=True;
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('增行失败!','提示',0);
  end;
end;

procedure TfrmYSCR.cxGridDBColumn8PropertiesEditValueChanged(
  Sender: TObject);
var
  mvalue,FFieldName:String;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;
  FFieldName:=Trim(Tv2.Controller.FocusedColumn.DataBinding.FilterFieldName);
  with CDS_HZ do
  begin
    Edit;
    FieldByName(FFieldName).Value:=Trim(mvalue);
    Post;
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YCL_SG_HZ ');
    if Trim(mvalue)<>'' then
    begin
      sql.Add(' Set '+FFieldName+'='''+Trim(mvalue)+'''');
    end else
    begin
      sql.Add(' Set '+FFieldName+'=NULL');
    end;
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where SubId='''+Trim(CDS_HZ.fieldbyname('SubId').AsString)+'''');
    ExecSQL;
  end;
end;

procedure TfrmYSCR.cxGridDBColumn5PropertiesEditValueChanged(
  Sender: TObject);
var
  mvalue,FQty,FPrice,FMoney,FHuiLv,FBBMoney,FKCBB,FFieldName:String;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;
  if Trim(mvalue)='' then
  begin
    mvalue:='NULL';
  end;
  FFieldName:=Trim(Tv2.Controller.FocusedColumn.DataBinding.FilterFieldName);
  if FFieldName='Money' then
  begin
    if Trim(CDS_HZ.fieldbyname('YSType').AsString)<>'' then
    begin
      Application.MessageBox('自动生成数据不能更改!','提示',0);
      Exit;
    end;
  end;
  if FFieldName='MaoQty' then
  begin
    if Trim(mvalue)<>'0' then
    begin
      if CDS_HZ.FieldByName('JZQty').AsFloat>strtofloat(mvalue)-CDS_HZ.FieldByName('ps').AsFloat*0.3 then
      begin
        application.MessageBox('毛重不能小于净重加纸管的重量','提示');
        with CDS_HZ do
        begin
          Edit;
          FieldByName(FFieldName).Value:=NULL;
        end;
        exit;
      end;
    end;
  end;
  with CDS_HZ do
  begin
    Edit;
    FieldByName(FFieldName).Value:=Trim(mvalue);
    if (fieldbyname('BZType').Value<>'￥') and (fieldbyname('BZType').Value<>'RMB') then
    begin
      fieldbyname('USDMoney').Value:=fieldbyname('Qty').AsFloat*fieldbyname('Price').AsFloat;
    end
    else
    begin
      fieldbyname('RMBMoney').Value:=fieldbyname('Qty').AsFloat*fieldbyname('Price').AsFloat;
    end;
    post;
  end;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select isnull(BBMoney,0) BBMoney from YF_Money_CR where YFID='''+cds_hz.fieldbyname('YFID').AsString+'''');
    Open;
  end;
  FKCBB:=ADOQueryTemp.fieldbyname('BBMoney').AsString;
  FQty:=Trim(CDS_HZ.fieldbyname('Qty').AsString);
  if Trim(FQty)='' then FQty:='0';

  FPrice:=Trim(CDS_HZ.fieldbyname('Price').AsString);
  if Trim(FPrice)='' then FPrice:='0';
  FQty:=Trim(CDS_HZ.fieldbyname('Qty').AsString);
  if Trim(FQty)='' then FQty:='0';

  FMoney:=Trim(CDS_HZ.fieldbyname('Money').AsString);
  if Trim(FMoney)='' then FMoney:='0';

  FHuiLv:=Trim(CDS_HZ.fieldbyname('HuiLv').AsString);
  if Trim(FHuiLv)='' then FHuiLv:='0';
    if Trim(FFieldName)<>'HuiLv' then
    begin
      FBBMoney:=FloatToStr(StrToFloat(FQty)*StrToFloat(FPrice)*StrToFloat(FHuiLv));
      FMoney:=FloatToStr(StrToFloat(FQty)*StrToFloat(FPrice));
    end else
    begin
      FBBMoney:=FloatToStr(StrToFloat(FMoney)*StrToFloat(FHuiLv));
    end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    sql.Add(' Set '+FFieldName+'='+Trim(mvalue));
    if Trim(FFieldName)<>'Money' then
    begin
      sql.Add(',Money='''+FMoney+'''');
    end;
    sql.Add(',BBMoney='''+FBBMoney+'''');
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    
    SQL.Add('Update YF_Money_KC Set KCBBMoney=KCBBMoney-'+FKCBB+'+'+FBBMoney);
    sql.Add(' where CRID='''+Trim(CDS_HZ.fieldbyname('CRID').AsString)+'''');
    ExecSQL;
  end;
  tv2.Controller.EditingController.ShowEdit();
end;

procedure TfrmYSCR.cxGridDBColumn1PropertiesEditValueChanged(
  Sender: TObject);
var
  mvalue,FFieldName:String;
begin
  if Trim(CDS_HZ.fieldbyname('YFType').AsString)<>'' then
  begin
    Application.MessageBox('自动生成数据不能更改!','提示',0);
    Exit;
  end; 
  mvalue:=TcxTextEdit(Sender).EditingText;
  FFieldName:=Trim(Tv2.Controller.FocusedColumn.DataBinding.FilterFieldName);
  with CDS_HZ do
  begin
    Edit;
    FieldByName(FFieldName).Value:=Trim(mvalue);
    Post;
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    if Trim(mvalue)<>'' then
    begin
      sql.Add(' Set '+FFieldName+'='''+Trim(mvalue)+'''');
    end else
    begin
      sql.Add(' Set '+FFieldName+'=NULL');
    end;
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    ExecSQL;
  end;
end;

procedure TfrmYSCR.ToolButton3Click(Sender: TObject);
begin
  {frmJYorderConCX:=TfrmJYorderConCX.create(self);
  with frmJYorderConCX do
  begin
    frmJYorderConCX.canshu3:=self.canshu2;
    if trim(fmanage)='高权限' then
    begin 
      formid:='1';
    end;
    if showmodal=1 then
    begin
      with Self.CDS_HZ do
      begin
        Append;
        FieldByName('FactoryNo').Value:=Trim(Order_Main.fieldbyname('CustomerNoName').AsString);
        FieldByName('FactoryName').Value:=Trim(Order_Main.fieldbyname('CustomerNoName').AsString);
        fieldbyname('MP_CodeName').Value:=Trim(Order_Main.fieldbyname('PrtCodeName').AsString);
        fieldbyname('MP_Spec').Value:=Trim(Order_Main.fieldbyname('prtspec').AsString);
        fieldbyname('PRTColor').Value:=Trim(Order_Main.fieldbyname('PRTColor').AsString);
        FieldByName('CRTime').Value:=SGetServerDate(ADOQueryTemp);
        fieldbyname('YFName').Value:='成品销售金额';
        fieldbyname('FeeType').Value:='其他费用';
        FieldByName('HuiLv').Value:=1;
        FieldByName('ConNoHZ').Value:=Trim(Order_Main.fieldbyname('ConNo').AsString);
        FieldByName('Conid').Value:=Trim(Order_Main.fieldbyname('subid').AsString);
        FieldByName('Price').Value:=Order_Main.fieldbyname('PRTPrice').AsFloat;
        FieldByName('BZType').Value:=Trim(Order_Main.fieldbyname('priceUnit').AsString);
        fieldbyname('ComTaitou').Value:=Trim(Order_Main.fieldbyname('SYRName').AsString);
        Post;
      end;
      Self.SaveData();
    end;
    free;
  end;}
  frmZdyAttachment:=TfrmZdyAttachment.Create(self);
  with frmZdyAttachment do
  begin
    if showmodal=1 then
    begin
      with Self.CDS_HZ do
      begin
        with Self.CDS_HZ do
        begin
          Append;
          FieldByName('FactoryNo').Value:=Trim(CDS_HZ.fieldbyname('ZdyCode').AsString);
          FieldByName('FactoryName').Value:=Trim(CDS_HZ.fieldbyname('ZdyName').AsString);
          FieldByName('CRTime').Value:=SGetServerDate(ADOQueryTemp);
          fieldbyname('YFName').Value:='成品销售金额';
          fieldbyname('FeeType').Value:='其他费用';
          FieldByName('HuiLv').Value:=1;
          FieldByName('BZType').Value:='￥';
          fieldbyname('ComTaitou').Value:='绍兴柯桥今墨纺织品有限公司';
          Post;
        end;
        Self.SaveData();
      end;
    end;
    Free;
  end;
end;

procedure TfrmYSCR.cxGridDBColumn3PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  if Trim(CDS_HZ.fieldbyname('YFType').AsString)<>'' then
  begin
    Application.MessageBox('自动生成数据不能更改!','提示',0);
    Exit;
  end;
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='YFName';
      flagname:='项目及摘要';
      MainType:=trim(DName);
      if ShowModal=1 then
      begin
        with Self.CDS_HZ do
        begin
          Edit;
          FieldByName('YFCode').Value:=Trim(ClientDataSet1.fieldbyname('ZdyNo').AsString);
          FieldByName('YFName').Value:=Trim(ClientDataSet1.fieldbyname('ZdyName').AsString);
          fieldbyname('FeeType').Value:='其他费用';
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set YFCode='''+Trim(ClientDataSet1.fieldbyname('ZdyNo').AsString)+'''');
          sql.Add(' ,YFName='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          sql.Add(' ,FeeType=''其他费用''');
          SQL.Add(',Editer='''+Trim(DName)+'''');
          SQL.Add(',Edittime=getdate() ');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYSCR.cxGridDBColumn6PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='OrderUnit';
      flagname:='数量单位';
      if ShowModal=1 then
      begin
        Self.CDS_HZ.Edit;
        Self.CDS_HZ.FieldByName('QtyUnit').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set QtyUnit='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(',Editer='''+Trim(DName)+'''');
          SQL.Add(',Edittime=getdate() ');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYSCR.v2Column3PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  if Trim(CDS_HZ.FieldByName('YFType').AsString)='自动生成' then
  begin
    Application.MessageBox('自动生成的数据不能修改!','提示',0);
    Exit;
  end;
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='MP_CodeName';
      flagname:='品名';
      if ShowModal=1 then
      begin
        Self.CDS_HZ.Edit;
        Self.CDS_HZ.FieldByName('MP_CodeName').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set P_CodeName='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(',Editer='''+Trim(DName)+'''');
          SQL.Add(',Edittime=getdate() ');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYSCR.ToolButton1Click(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then Exit;
  SelExportData(Tv2,ADOQueryMain,'应收款列表');
end;

procedure TfrmYSCR.v2Column7PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  {if Trim(CDS_HZ.FieldByName('YFType').AsString)='自动生成' then
  begin
    Application.MessageBox('自动生成的数据不能修改!','提示',0);
    Exit;
  end;}
  try
    frmProductOrderNewList:=TfrmProductOrderNewList.Create(Application);
    with frmProductOrderNewList do
    begin
      //frmProductOrderList.v1Column4.Visible:=True;
      if ShowModal=1 then
      begin
        with Self.CDS_HZ do
        begin
          Edit;
          FieldByName('MainId').Value:=Trim(frmProductOrderNewList.Order_Main.fieldbyname('MainId').AsString);
          FieldByName('subID').Value:=Trim(frmProductOrderNewList.Order_Main.fieldbyname('subID').AsString);
          FieldByName('MOrderNo').Value:=Trim(frmProductOrderNewList.Order_Main.fieldbyname('OrderNo').AsString);
          FieldByName('MP_CodeName').Value:=Trim(frmProductOrderNewList.Order_Main.fieldbyname('MPRTCodeName').AsString);
          FieldByName('MP_Spec').Value:=Trim(frmProductOrderNewList.Order_Main.fieldbyname('MPRTSpec').AsString);
          post;
          with ADOQueryCmd do
          begin
            Close;
            sql.Clear;
            sql.Add('UPdate YF_Money_CR ');
            sql.Add(' Set MainId='''+Trim(SELF.CDS_HZ.fieldbyname('MainId').AsString)+'''');
            sql.Add(' ,SubId='''+Trim(SELF.CDS_HZ.fieldbyname('SubId').AsString)+'''');
            sql.Add(' ,p_CodeName='''+Trim(SELF.CDS_HZ.fieldbyname('MP_CodeName').AsString)+'''');
            sql.Add(' ,P_Spec='''+Trim(SELF.CDS_HZ.fieldbyname('MP_Spec').AsString)+'''');
            SQL.Add(',Editer='''+Trim(DName)+'''');
            SQL.Add(',Edittime=getdate() ');
            SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
            ExecSQL;
          end;
        end;
      end;
    end;
  finally
    frmProductOrderNewList.Free;
    self.Tv2.Controller.EditingController.ShowEdit();
  end;
end;

procedure TfrmYSCR.v2PSPropertiesEditValueChanged(Sender: TObject);
var
  mvalue,FFieldName:String;
begin
  if Trim(CDS_HZ.FieldByName('YFType').AsString)='自动生成' then
  begin
    Application.MessageBox('自动生成的数据不能修改!','提示',0);
    Exit;
  end;
  mvalue:=TcxTextEdit(Sender).EditingText;
  if Trim(mvalue)='' then
  begin
    mvalue:='0';
  end;
  FFieldName:=Trim(Tv2.Controller.FocusedColumn.DataBinding.FilterFieldName);
  with CDS_HZ do
  begin
    Edit;
    FieldByName(FFieldName).Value:=Trim(mvalue);
    Post;
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    sql.Add(' Set '+FFieldName+'='+Trim(mvalue));
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    ExecSQL;
  end;
end;

procedure TfrmYSCR.v2Column2PropertiesEditValueChanged(Sender: TObject);
var
  mvalue,FFieldName:String;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;
  FFieldName:=Trim(Tv2.Controller.FocusedColumn.DataBinding.FilterFieldName);
  with CDS_HZ do
  begin
    Edit;
    FieldByName(FFieldName).Value:=Trim(mvalue);
    Post;
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    sql.Add(' Set '+FFieldName+'='''+Trim(mvalue)+'''');
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    ExecSQL;
  end;
end;

procedure TfrmYSCR.v2KPMoneyPropertiesEditValueChanged(Sender: TObject);
var
  mvalue,FBBMoney,FKCBB,FFieldName:String;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;
  if Trim(mvalue)='' then
  begin
    mvalue:='0';
  end;
  FFieldName:=Trim(Tv2.Controller.FocusedColumn.DataBinding.FilterFieldName);
  with CDS_HZ do
  begin
    Edit;
    FieldByName(FFieldName).Value:=Trim(mvalue);
    Post;
  end;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select isnull(KPMoney,0) KPMoney from YF_Money_CR where YFID='''+cds_hz.fieldbyname('YFID').AsString+'''');
    Open;
  end;
  FKCBB:=ADOQueryTemp.fieldbyname('KPMoney').AsString;
  FBBMoney:=CDS_HZ.fieldbyname('KPMoney').AsString;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    sql.Add(' Set '+FFieldName+'='+Trim(mvalue));
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    SQL.Add('Update YF_Money_KC Set KCKPMoney=KCKPMoney-'+FKCBB+'+'+FBBMoney);
    sql.Add(' where CRID='''+Trim(CDS_HZ.fieldbyname('CRID').AsString)+'''');
    ExecSQL;
  end;
end;

procedure TfrmYSCR.Button1Click(Sender: TObject);
begin

  IF CDS_HZ.IsEmpty then exit;

  if CDS_HZ.Locate('ssel',true,[])=false then
  begin
    Application.MessageBox('没有选择数据!','提示',0);
    Exit;
  end;
  ADOQueryCmd.Connection.BeginTrans;
  try
    with CDS_HZ do
    begin
      DisableControls;
      First;
      while not eof do
      begin
        If fieldbyname('ssel').AsBoolean then
        begin
          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('select * from YF_Money_CR ');
            sql.Add('where YFID='+quotedstr(trim(CDS_HZ.fieldbyname('YFID').AsString)));
            open;
            edit;
            Fieldbyname('Price').Value:=strtofloatdef(edit1.Text,0);
            Fieldbyname('Money').Value:=format('%.2f',[Fieldbyname('Qty').AsFloat * strtofloatdef(edit1.Text,0) ]);
            Fieldbyname('BBMoney').Value:=format('%.2f',[Fieldbyname('Qty').AsFloat * strtofloatdef(edit1.Text,0) ]);
            post;
          end;
        end;
        next;
      end;
      First;
      EnableControls;
    end;
    ADOQueryCmd.Connection.CommitTrans;
    InitGrid();
  except
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox('数据保存失败！','提示信息',0);
  end;

end;

procedure TfrmYSCR.CheckBox1Click(Sender: TObject);
begin
 IF  CDS_HZ.IsEmpty then exit;
 Label12.Caption:='0';
 Label13.Caption:='0';
 Label19.Caption:='0';
  with CDS_HZ do
  begin
    DisableControls;
    first;
    while not eof do
    begin
      edit;
      fieldbyname('ssel').Value:=checkbox1.Checked;
      if checkbox1.Checked=true then
      begin
      Label12.Caption:=floattostr(strtofloat(Label12.Caption)+fieldbyname('Qty').AsCurrency);
      Label13.Caption:=floattostr(strtofloat(Label13.Caption)+fieldbyname('USDMoney').AsCurrency);
      Label19.Caption:=floattostr(strtofloat(Label19.Caption)+fieldbyname('RMBMoney').AsCurrency);
      end;
      post;
      next;
    end;
    First;
    EnableControls;
  end;
end;

procedure TfrmYSCR.cxTabControl1Change(Sender: TObject);
begin
  SetStatus();

  InitGrid();
end;

procedure TfrmYSCR.FormCreate(Sender: TObject);
begin
  cxGrid2.Align:=alclient;
  canshu2:=trim(DParameters2);
end;

procedure TfrmYSCR.TchkClick(Sender: TObject);
begin
  IF CDS_HZ.IsEmpty then exit;
  if cxtabcontrol1.TabIndex<>0 then exit;
  if CDS_HZ.Locate('ssel',true,[])=false then
  begin
    Application.MessageBox('没有选择数据!','提示',0);
    Exit;
  end;
  with CDS_HZ do
  begin
    first;
    while not eof do
    begin
      if cds_HZ.FieldByName('Ssel').AsBoolean=true then
      begin
        
        if cds_HZ.FieldByName('SJFHDate').Value=NULL then
        begin
          application.MessageBox('实际发货日期不能为空','提示');
          exit;
        end;
        if cds_HZ.FieldByName('BZType').AsString='' then
        begin
          application.MessageBox('币种不能为空','提示');
          exit;
        end;
        {if cds_HZ.FieldByName('KPNO').AsString='' then
        begin
          application.MessageBox('发票号不能为空','提示');
          exit;
        end;}
        if cds_HZ.FieldByName('QtyUnit').AsString='' then
        begin
          application.MessageBox('数量单位不能为空','提示');
          exit;
        end;
      end;
      next;
    end;
  end;
  with CDS_HZ do
  begin
    DisableControls;
    while CDS_HZ.Locate('ssel',true,[]) do
    begin
      with ADOQueryCmd do
      begin
        close;
        sql.Clear;
        sql.Add('update YF_Money_CR SET status=''1'',chkstatus=NULL ');
        sql.Add('where YFID ='+quotedstr(trim(CDS_HZ.fieldbyname('YFID').AsString)));
        execsql;
      end;
      CDS_HZ.Delete;
    end;
    EnableControls;
  end;
  application.MessageBox('操作成功！','提示信息',0);
  //InitGrid();
end;

procedure TfrmYSCR.TnochkClick(Sender: TObject);
begin
  IF CDS_HZ.IsEmpty then exit;
  if CDS_HZ.Locate('ssel',true,[])=false then
  begin
    Application.MessageBox('没有选择数据!','提示',0);
    Exit;
  end;
  try
    ADOQueryCmd.Connection.BeginTrans;
    with CDS_HZ do
    begin
      DisableControls;
      First;
      while not eof do
      begin
        IF Fieldbyname('ssel').AsBoolean=true then
        begin
          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('update YF_Money_CR SET status=''0'' ');
            sql.Add('where YFID ='+quotedstr(trim(CDS_HZ.fieldbyname('YFID').AsString)));
            execsql;
          end;
        end;
        next;
      end;
      First;
      EnableControls;
    end;
    InitGrid();
    ADOQueryCmd.Connection.CommitTrans;
    application.MessageBox('操作成功！','提示信息',0);
  except
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox('操作失败！','提示信息',0);
  end;
end;

procedure TfrmYSCR.v2ComTaitouPropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='ComTaiTou';
      flagname:='公司抬头';
      if ShowModal=1 then
      begin
        with Self.CDS_HZ do
        begin
          Edit;
          FieldByName('ComTaiTou').Value:=Trim(ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set ComTaiTou='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(',Editer='''+Trim(DName)+'''');
          SQL.Add(',Edittime=getdate() ');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYSCR.TZDSCClick(Sender: TObject);
begin
  frmSXCKNewList_SK:=TfrmSXCKNewList_SK.create(self) ;
  with frmSXCKNewList_SK do
  begin
    FfeeType:='坯布费用';
    FCRType:='检验';
    show;
  end;
end;

procedure TfrmYSCR.VBZPropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  {if Trim(CDS_HZ.FieldByName('YFType').AsString)='自动生成' then
  begin
    Application.MessageBox('自动生成的数据不能修改!','提示',0);
    Exit;
  end;}
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='BZType';
      flagname:='币种';
      if ShowModal=1 then
      begin
        Self.CDS_HZ.Edit;
        Self.CDS_HZ.FieldByName('BZType').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set BZType='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(',Editer='''+Trim(DName)+'''');
          SQL.Add(',Edittime=getdate() ');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYSCR.v2Column4PropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  if Trim(CDS_HZ.FieldByName('YFType').AsString)='自动生成' then
  begin
    Application.MessageBox('自动生成的数据不能修改!','提示',0);
    Exit;
  end;
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='MP_spec';
      flagname:='规格';
      if ShowModal=1 then
      begin
        Self.CDS_HZ.Edit;
        Self.CDS_HZ.FieldByName('MP_spec').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set P_Spec='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(',Editer='''+Trim(DName)+'''');
          SQL.Add(',Edittime=getdate() ');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmYSCR.v2Column5PropertiesChange(Sender: TObject);
begin
  toolbar1.SetFocus;
  HJ(CDS_HZ,Label12,CDS_HZ.fieldbyname('Qty').AsCurrency);
  HJ(CDS_HZ,Label13,CDS_HZ.fieldbyname('USDMoney').AsCurrency);
  HJ(CDS_HZ,Label19,CDS_HZ.fieldbyname('RMBMoney').AsCurrency);
  HJ(CDS_HZ,Label21,CDS_HZ.fieldbyname('PS').AsCurrency);
end;

procedure TfrmYSCR.v2ConNoHZPropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  {if Trim(CDS_HZ.FieldByName('YFType').AsString)='自动生成' then
  begin
    Application.MessageBox('自动生成的数据不能修改!','提示',0);
    Exit;
  end;}
  frmJYorderConCX:=TfrmJYorderConCX.create(self);
  with frmJYorderConCX do
  begin
    if Self.fmanage='高权限' then
    formid:='1';
    if showmodal=1 then
    begin
      Self.CDS_HZ.Edit;
      Self.CDS_HZ.FieldByName('ConNoHZ').Value:=Trim(Order_Main.fieldbyname('ConNo').AsString);
      Self.CDS_HZ.FieldByName('Conid').Value:=Trim(Order_Main.fieldbyname('subid').AsString);
      Self.CDS_HZ.FieldByName('MP_CodeName').Value:=Order_Main.fieldbyname('PrtCodeName').AsString;
      Self.CDS_HZ.FieldByName('MP_Spec').Value:=Order_Main.fieldbyname('prtspec').AsString;
      Self.CDS_HZ.FieldByName('BZType').Value:=Order_Main.fieldbyname('PriceUnit').AsString;
      Self.CDS_HZ.FieldByName('SOrdDefStr4').Value:=Order_Main.fieldbyname('SOrdDefStr4').AsString;
      Self.CDS_HZ.FieldByName('PRTColor').Value:=Order_Main.fieldbyname('PRTColor').AsString;
      Self.CDS_HZ.FieldByName('FactoryNo').Value:=Trim(Order_Main.fieldbyname('CustomerNoName').AsString);
      Self.CDS_HZ.FieldByName('FactoryName').Value:=Trim(Order_Main.fieldbyname('CustomerNoName').AsString);
      if Self.CDS_HZ.FieldByName('YFName').Value='针织上机费' then
      begin
        if (self.CDS_HZ.FieldByName('BZType').AsString='$') or (self.CDS_HZ.FieldByName('BZType').AsString='USD') then
        Self.CDS_HZ.FieldByName('USDMoney').Value:=Order_Main.fieldbyname('ZhenZhiSJFee').AsFloat;
        if (self.CDS_HZ.FieldByName('BZType').AsString='￥') or (self.CDS_HZ.FieldByName('BZType').AsString='RMB') then
        Self.CDS_HZ.FieldByName('RMBMoney').Value:=Order_Main.fieldbyname('ZhenZhiSJFee').AsFloat;
        Self.CDS_HZ.FieldByName('Price').Value:=Order_Main.fieldbyname('ZhenZhiSJFee').AsFloat;
      end;
      if Self.CDS_HZ.FieldByName('YFName').Value='印花上机费' then
      begin
        if (self.CDS_HZ.FieldByName('BZType').AsString='$') or (self.CDS_HZ.FieldByName('BZType').AsString='USD') then
        Self.CDS_HZ.FieldByName('USDMoney').Value:=Order_Main.fieldbyname('YinHuaSJFee').AsFloat;
        if (self.CDS_HZ.FieldByName('BZType').AsString='￥') or (self.CDS_HZ.FieldByName('BZType').AsString='RMB') then
        Self.CDS_HZ.FieldByName('RMBMoney').Value:=Order_Main.fieldbyname('YinHuaSJFee').AsFloat;
        Self.CDS_HZ.FieldByName('Price').Value:=Order_Main.fieldbyname('YinHuaSJFee').AsFloat;
      end;
      if Self.CDS_HZ.FieldByName('YFName').Value='包缸费' then
      begin
        if (self.CDS_HZ.FieldByName('BZType').AsString='$') or (self.CDS_HZ.FieldByName('BZType').AsString='USD') then
        Self.CDS_HZ.FieldByName('USDMoney').Value:=Order_Main.fieldbyname('BaoGangFee').AsFloat;
        if (self.CDS_HZ.FieldByName('BZType').AsString='￥') or (self.CDS_HZ.FieldByName('BZType').AsString='RMB') then
        Self.CDS_HZ.FieldByName('RMBMoney').Value:=Order_Main.fieldbyname('BaoGangFee').AsFloat;
        Self.CDS_HZ.FieldByName('Price').Value:=Order_Main.fieldbyname('BaoGangFee').AsFloat;
      end;
      if Self.CDS_HZ.FieldByName('YFName').Value='制网制版费' then
      begin
        if (self.CDS_HZ.FieldByName('BZType').AsString='$') or (self.CDS_HZ.FieldByName('BZType').AsString='USD') then
        Self.CDS_HZ.FieldByName('USDMoney').Value:=Order_Main.fieldbyname('ZhiWangZhiBanFee').AsFloat*Order_Main.FieldByName('TaoQty').AsFloat;
        if (self.CDS_HZ.FieldByName('BZType').AsString='￥') or (self.CDS_HZ.FieldByName('BZType').AsString='RMB') then
        Self.CDS_HZ.FieldByName('RMBMoney').Value:=Order_Main.fieldbyname('ZhiWangZhiBanFee').AsFloat*Order_Main.FieldByName('TaoQty').AsFloat;
        Self.CDS_HZ.FieldByName('Price').Value:=Order_Main.fieldbyname('ZhiWangZhiBanFee').AsFloat*Order_Main.FieldByName('TaoQty').AsFloat;
      end;
      if Self.CDS_HZ.FieldByName('YFName').Value='成品销售金额' then
      begin
        if (self.CDS_HZ.FieldByName('BZType').AsString='$') or (self.CDS_HZ.FieldByName('BZType').AsString='USD') then
        Self.CDS_HZ.FieldByName('USDMoney').Value:=Self.CDS_HZ.fieldbyname('Qty').AsFloat*Order_Main.fieldbyname('PRTPrice').AsFloat;
        if (self.CDS_HZ.FieldByName('BZType').AsString='￥') or (self.CDS_HZ.FieldByName('BZType').AsString='RMB') then
        Self.CDS_HZ.FieldByName('RMBMoney').Value:=Self.CDS_HZ.fieldbyname('Qty').AsFloat*Order_Main.fieldbyname('PRTPrice').AsFloat;
        //Self.CDS_HZ.FieldByName('Price').Value:=Order_Main.fieldbyname('PRTPrice').AsFloat;
      end;
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add('UPdate YF_Money_CR ');
        sql.Add(' Set Conid='''+Trim(Order_Main.fieldbyname('subid').AsString)+'''');
        sql.add(',ConNo='''+Trim(Order_Main.fieldbyname('ConNo').AsString)+'''');
        sql.add(',Price='''+Trim(SELF.CDS_HZ.fieldbyname('Price').AsString)+'''');
        sql.Add(',p_CodeName='''+Trim(SELF.CDS_HZ.fieldbyname('MP_CodeName').AsString)+'''');
        sql.Add(',P_Spec='''+Trim(SELF.CDS_HZ.fieldbyname('MP_Spec').AsString)+'''');
        sql.Add(',FactoryName='''+Trim(SELF.CDS_HZ.fieldbyname('FactoryName').AsString)+'''');
        sql.Add(',FactoryNo='''+Trim(SELF.CDS_HZ.fieldbyname('FactoryNo').AsString)+'''');
        if (self.CDS_HZ.FieldByName('BZType').AsString='$') or (self.CDS_HZ.FieldByName('BZType').AsString='USD') then
        sql.add(',Money='''+trim(SELF.CDS_HZ.fieldbyname('USDMoney').AsString)+'''');
        if (self.CDS_HZ.FieldByName('BZType').AsString='￥') or (self.CDS_HZ.FieldByName('BZType').AsString='RMB') then
        sql.add(',Money='''+trim(SELF.CDS_HZ.fieldbyname('RMBMoney').AsString)+'''');
        sql.Add(',BZType='''+Trim(SELF.CDS_HZ.fieldbyname('BZType').AsString)+'''');
        SQL.Add(',Editer='''+Trim(DName)+'''');
        SQL.Add(',Edittime=getdate() ');
        SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
        ExecSQL;
      end;
    end;
    free;
  end;
end;

procedure TfrmYSCR.Tv2StylesGetContentStyle(Sender: TcxCustomGridTableView;
  ARecord: TcxCustomGridRecord; AItem: TcxCustomGridTableItem;
  out AStyle: TcxStyle);
var
  id,id10:Integer;
begin
  Id:=Tv2.GetColumnByFieldName('ChkStatus').Index;
  if cxtabcontrol1.TabIndex=0 then
  begin
    if ARecord.Values[id]<>NULL then
    begin
      AStyle:=DataLink_YSYF.Red;
    end;
  end;
end;

procedure TfrmYSCR.N1Click(Sender: TObject);
begin
  SelOKNo(CDS_HZ,True);
end;

procedure TfrmYSCR.N2Click(Sender: TObject);
begin
  SelOKNo(CDS_HZ,false);
end;

procedure TfrmYSCR.ToolButton4Click(Sender: TObject);
begin
  IF CDS_HZ.IsEmpty then exit;

  if CDS_HZ.Locate('ssel',true,[])=false then
  begin
    Application.MessageBox('没有选择数据!','提示',0);
    Exit;
  end;
  try
    ADOQueryCmd.Connection.BeginTrans;
    with CDS_HZ do
    begin
      DisableControls;
      First;
      while not eof do
      begin
        IF Fieldbyname('ssel').AsBoolean=true then
        begin
          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('update YF_Money_CR SET KPStatus=''开票完成'' ');
            sql.Add('where YFID ='+quotedstr(trim(CDS_HZ.fieldbyname('YFID').AsString)));
            execsql;
          end;
        end;
        next;
      end;
      First;
      EnableControls;
    end;

    InitGrid();
    ADOQueryCmd.Connection.CommitTrans;
    application.MessageBox('操作成功！','提示信息',0);
  except
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox('操作失败！','提示信息',0);
  end;
end;

procedure TfrmYSCR.ToolButton5Click(Sender: TObject);
begin
  IF CDS_HZ.IsEmpty then exit;

  if CDS_HZ.Locate('ssel',true,[])=false then
  begin
    Application.MessageBox('没有选择数据!','提示',0);
    Exit;
  end;
  try
    ADOQueryCmd.Connection.BeginTrans;
    with CDS_HZ do
    begin
      DisableControls;
      First;
      while not eof do
      begin
        IF Fieldbyname('ssel').AsBoolean=true then
        begin
          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('update YF_Money_CR SET KPStatus='''' ');
            sql.Add('where YFID ='+quotedstr(trim(CDS_HZ.fieldbyname('YFID').AsString)));
            execsql;
          end;
        end;
        next;
      end;
      First;
      EnableControls;
    end;

    InitGrid();
    ADOQueryCmd.Connection.CommitTrans;
    application.MessageBox('操作成功！','提示信息',0);
  except
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox('操作失败！','提示信息',0);
  end;
end;

procedure TfrmYSCR.v2KPTypePropertiesEditValueChanged(Sender: TObject);
var
  mvalue,FFieldName:String;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;
  with CDS_HZ do
  begin
    Edit;
    FieldByName('KPType').Value:=Trim(mvalue);
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    sql.Add(' Set KPType='''+Trim(mvalue)+'''');
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    ExecSQL;
  end;
end;

procedure TfrmYSCR.VYBPropertiesEditValueChanged(Sender: TObject);
 var
  mvalue,FFieldName:String;
begin
  if CDS_HZ.FieldByName('BZType').AsString='' then
  begin
    application.MessageBox('请先录入币种','提示');
    exit;
  end;
  mvalue:=TcxTextEdit(Sender).EditingText;
  if mvalue='' then
  begin
    mvalue:='0';
  end;
  with CDS_HZ do
  begin
    Edit;
    FieldByName('USDMoney').Value:=Trim(mvalue);
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    sql.Add(' Set Money='''+Trim(mvalue)+'''');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    ExecSQL;
  end;
end;

procedure TfrmYSCR.VRMBMoneyPropertiesEditValueChanged(Sender: TObject);
var
  mvalue,FFieldName:String;
begin
  if CDS_HZ.FieldByName('BZType').AsString='' then
  begin
    application.MessageBox('请先录入币种','提示');
    exit;
  end;
  mvalue:=TcxTextEdit(Sender).EditingText;
  if mvalue='' then
  begin
    mvalue:='0';
  end;
  with CDS_HZ do
  begin
    Edit;
    FieldByName('RMBMoney').Value:=Trim(mvalue);
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    sql.Add(' Set Money='''+Trim(mvalue)+'''');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    ExecSQL;
  end;
end;

procedure TfrmYSCR.Tv2CellDblClick(Sender: TcxCustomGridTableView;
  ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton;
  AShift: TShiftState; var AHandled: Boolean);
begin
  frmDJBCKKCList_DDSH:=TfrmDJBCKKCList_DDSH.create(self);
  with frmDJBCKKCList_DDSH do
  begin
    formid:='1';
    if showmodal=1 then
    begin

    end;
    free;
  end;
end;

procedure TfrmYSCR.Tv2CellClick(Sender: TcxCustomGridTableView;
  ACellViewInfo: TcxGridTableDataCellViewInfo; AButton: TMouseButton;
  AShift: TShiftState; var AHandled: Boolean);
begin
  if CDS_Main.IsEmpty=False then
  begin
     if (CDS_Main.FieldByName('ConNO').AsString=CDS_HZ.FieldByName('ConNoHZ').AsString)
     and (CDS_HZ.fieldbyname('MP_CodeName').asstring=CDS_Main.FieldByName('PrtCodeName').AsString)
     and (CDS_HZ.fieldbyname('MP_Spec').asstring=CDS_Main.FieldByName('PRTspec').AsString) then exit;
     //and (CDS_HZ.fieldbyname('PRTColor').asstring=CDS_Main.FieldByName('PRTColor').AsString)
     //and (CDS_HZ.fieldbyname('SOrdDefStr4').asstring=CDS_Main.FieldByName('SOrdDefStr4').AsString)
  end;
  Panel2.Visible:=true;
  Panel2.Refresh;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add(' Select PBCKDate=(select Top 1 F.CRTime from CK_SXPB_CR F inner join CK_SXPB_CR G on G.ORDMainidCK=F.ORDMainidCK and F.CRFlag=''出库'' ');
    sql.add(' and isnull(F.CKName,'''')=''坯布'' and G.CRFlag=''出库'' and isnull(G.CKName,'''')=''待检布'' and isnull(G.CRType,'''')=''检验出库'' ');
    sql.add(' inner join JYOrderCon_Sub H on H.Subid=G.ConCKID inner join JYOrderCon_Main I on I.Mainid=H.Mainid where I.ConNo=AAA.ConNo order by F.CRTime desc) ');
    sql.add(',HCDate=(select Top 1 F.CRTime from CK_SXPB_CR F inner join CK_SXPB_CR G on G.ORDMainidCK=F.ORDMainidRK and F.CRFlag=''入库'' ');
    sql.add(' and isnull(F.CKName,'''')=''待检布'' and G.CRFlag=''出库'' and isnull(G.CKName,'''')=''待检布'' and isnull(G.CRType,'''')=''检验出库'' ');
    sql.add(' inner join JYOrderCon_Sub H on H.Subid=G.ConCKID inner join JYOrderCon_Main I on I.Mainid=H.Mainid where I.ConNo=AAA.ConNo order by F.CRTime desc) ');
    sql.add(',CKDate=(select Top 1 F.CRTime from CK_BanCP_CR F where F.ConNo=AAA.ConNO and F.CRFlag=''出库'' and F.CPType=''正品'' order by F.CRTime desc) ');
    sql.add(',AAA.*,PBSH=(case when isnull(DDTPQty,0)<>0 then (DDTPQty-KGQty)/DDTPQty*100 else 0 end) ');
    sql.add(',JYSH=(case when isnull(KGQty,0)=0 then 0 else (KGQty-JYZQty)/KGQty*100 end) ');
    sql.add(',CPKC=(sumJYQty-SumCKQty-SumHXCKQty) ');
    sql.add('from (select AA.ConNo,AA.XHNO,AA.Subid,AA.StyleNo,AA.PrtCode,AA.PrtCodeName,AA.PRTspec,AA.SOrdDefStr4,AA.PRTColorNo,AA.PRTHX,AA.PRTColor,AA.PRTMF,AA.PRTKZ,AA.PRTOrderQty,AA.OrderUnit ');
    sql.add(',Sum(AA.Qty) DJCKQty,Sum(AA.PiQty) DJCKPS,Sum(AA.JYQty) sumJYQty,Sum(AA.JYPS) sumJYPS,Sum(AA.JYCPQty) sumJYCPQty,Sum(AA.JYCPPS) sumJYCPPS ');
    sql.add(',Sum(JYZQty) JYZQty,sum(JYZPS) JYZPS,Sum(KGQty) KGQty');
    sql.add(',DDTPQty=Sum(case when isnull(AA.DJRKQty,0)=0 then 0 else cast(AA.Qty/AA.DJRKQty*AA.TPQty as decimal(18,2)) end) ');
    sql.add(',DDTPPS=Sum(case when isnull(AA.DJRKPS,0)=0 then 0 else cast(AA.PiQty/AA.DJRKPS*AA.TPPS as decimal(18,0)) end) ');
    sql.add(',JYDate=(select Top 1 Q.FillTime from WFB_MJJY Q where Q.CONID=AA.Subid order by Q.FillTime desc) ');
    sql.add(',SumCKPS=(select isnull(COUNT(G.MJID),0) from CK_BanCP_CR G where G.ConID=AA.Subid and G.CRFlag=''入库'' and G.CPType=''正品'' and G.CRType=''检验入库'') ');
    sql.add(',SumCKQty=(select isnull(Sum(G.JZQty),0) from CK_BanCP_CR G where G.ConID=AA.Subid and G.CRFlag=''入库'' and G.CPType=''正品'' and G.CRType=''检验入库'') ');
    sql.add(',SumHXCKPS=(select isnull(COUNT(G.MJID),0) from CK_BanCP_CR G where G.ConID=AA.Subid and G.CRFlag=''入库'' and G.CPType=''正品'' and G.CRType<>''检验入库'') ');
    sql.add(',SumHXCKQty=(select isnull(Sum(G.JZQty),0) from CK_BanCP_CR G where G.ConID=AA.Subid and G.CRFlag=''入库'' and G.CPType=''正品'' and G.CRType<>''检验入库'') ');
    sql.add('from ( ');
    sql.add('select ConNo,Subid,XHNo,ORDSubIdRK,StyleNo,PrtCode,PrtCodeName,PRTspec,SOrdDefStr4,PRTColorNo,PRTHX,PRTColor,PRTMF,PRTKZ,PRTOrderQty,OrderUnit,DJRKQty,DJRKPS,TPQty,TPPS ');
    sql.add(',Sum(Qty) Qty,Sum(PiQty) PiQty,Sum(KGQty) KGQty,SUM(JYZQty) JYZQty,SUM(JYZPS) JYZPS,SUM(JYQty) JYQty,SUM(JYPS) JYPS,SUM(JYCPQty) JYCPQty,SUM(JYCPPS) JYCPPS ');
    sql.add('from ( ');
    sql.add('select C.ConNo,A.SPID,A.ConCKID Subid,B.XHNo,A.OrdMainidCK,A.ORDSubIdRK,B.StyleNo,B.PrtCode,B.PrtCodeName,B.PRTspec,B.SOrdDefStr4,B.PRTColorNo,B.PRTHX,B.PRTColor,B.PRTMF,B.PRTKZ,B.PRTOrderQty,B.OrderUnit,A.Qty,A.PiQty');
    sql.Add(',KGQty=(case when A.QtyUnit=''KG'' then A.Qty else (case when D.XS=0 then 0 else A.Qty/D.XS end) end) ');
    sql.add(',JYZQty=(select sum(MJQty4) from WFB_MJJY Q where Q.APID=A.SPID)'); //Q.APID=A.SPID:检验后转单导致与待检出库数据不匹配
    sql.add(',JYZPS=(select count(MJID) from WFB_MJJY Q where Q.APID=A.SPID ) ');
    sql.add(',JYQty=(select sum(MJQty4) from WFB_MJJY Q where Q.APID=A.SPID and Q.MJType=''正品'')');
    sql.add(',JYPS=(select count(MJID) from WFB_MJJY Q where Q.APID=A.SPID and Q.MJType=''正品'') ');
    sql.add(',JYCPQty=(select sum(MJQty4) from WFB_MJJY Q where Q.APID=A.SPID and Q.MJType=''次品'')');
    sql.add(',JYCPPS=(select count(MJID) from WFB_MJJY Q where Q.APID=A.SPID and Q.MJType=''次品'') ');

    sql.add(',DJRKQty=(select isnull(Sum(Q.Qty),0) From CK_SXPB_CR Q inner join CK_SXPB_CR H on Q.SPID=H.FZSPID where H.CRType=''检验出库'' and Q.OrdSubidRK=A.OrdSubidRK and Q.CRFlag=''入库'' and isnull(Q.CKName,'''')=''待检布'' and Q.CRType=''加工完成'') ');
    sql.add(',DJRKPS=(select isnull(Sum(Q.PiQty),0) From CK_SXPB_CR Q inner join CK_SXPB_CR H on Q.SPID=H.FZSPID where H.CRType=''检验出库'' and Q.OrdSubidRK=A.OrdSubidRK and Q.CRFlag=''入库'' and isnull(Q.CKName,'''')=''待检布'' and Q.CRType=''加工完成'') ');
    sql.add(',TPQty=(select isnull(Sum(Q.Qty),0) from CK_SXPB_CR Q left join CK_SXPB_CR G on G.SPID=Q.FZSPID where Q.ORDSubIdCK=A.ORDSubIdRK and Q.CRFlag=''出库'' and isnull(Q.CKName,'''')=''坯布'' and G.CRType<>''加工完成'') ');
    sql.add(',TPPS=(select isnull(Sum(Q.PiQty),0) from CK_SXPB_CR Q left join CK_SXPB_CR G on G.SPID=Q.FZSPID where Q.ORDSubIdCK=A.ORDSubIdRK and Q.CRFlag=''出库'' and isnull(Q.CKName,'''')=''坯布'' and G.CRType<>''加工完成'') ');
    sql.add('from CK_SXPB_CR A ');
    sql.Add('inner join JYOrder_Main D on D.Mainid=A.OrdMainidCK ');
    sql.add('inner join JYOrderCon_Sub B on B.SubId=A.ConCKID  ');
    sql.add('inner join JYOrderCon_Main C on C.MainId=B.MainId  ');
    sql.add('where A.CRFlag=''出库'' and isnull(A.CKName,'''')=''待检布'' ');
    sql.add('and isnull(A.CRType,'''')=''检验出库'' ');
    sql.add(' and C.ConNO='''+Trim(CDS_HZ.fieldbyname('ConNOHZ').asstring)+''' and isnull(B.PrtCodeName,'''')='''+trim(CDS_HZ.fieldbyname('MP_CodeName').asstring)+'''');
    //sql.add(' and isnull(B.PRTColor,'''')='''+trim(CDS_HZ.fieldbyname('PRTColor').asstring)+''' ');
    //sql.Add(' and isnull(B.SOrdDefStr4,'''')='''+trim(CDS_HZ.fieldbyname('SOrdDefStr4').asstring)+'''');
    sql.add(') QQ ');
    sql.add('group by ConNo,Subid,XHNo,ORDSubIdRK,StyleNo,PrtCode,PrtCodeName,PRTspec,SOrdDefStr4,PRTColorNo,PRTHX,PRTColor,PRTMF,PRTKZ,PRTOrderQty,OrderUnit,DJRKQty,DJRKPS,TPQty,TPPS)AA ');
    sql.add('group by AA.ConNo,AA.XHNO,AA.Subid,AA.StyleNo,AA.PrtCode,AA.PrtCodeName,AA.PRTspec,AA.SOrdDefStr4,AA.PRTColorNo,AA.PRTHX,AA.PRTColor,AA.PRTMF,AA.PRTKZ,AA.PRTOrderQty,AA.OrderUnit ) AAA ');
    sql.add(' order by AAA.XHNO');
    Open;
  end;
  SCreateCDS20(ADOQueryTemp,CDS_Main);
  SInitCDSData20(ADOQueryTemp,CDS_Main);
  Panel2.Visible:=false;
end;

procedure TfrmYSCR.v2KPNOPropertiesEditValueChanged(Sender: TObject);
var
  mvalue,FFieldName:String;
begin
  mvalue:=TcxTextEdit(Sender).EditingText;
  FFieldName:=Trim(Tv2.Controller.FocusedColumn.DataBinding.FilterFieldName);
  with CDS_HZ do
  begin
    Edit;
    FieldByName(FFieldName).Value:=Trim(mvalue);
    Post;
  end;
  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add('UPdate YF_Money_CR ');
    if Trim(mvalue)<>'' then
    begin
      sql.Add(' Set '+FFieldName+'='''+Trim(mvalue)+'''');
    end else
    begin
      sql.Add(' Set '+FFieldName+'=NULL');
    end;
    SQL.Add(',Editer='''+Trim(DName)+'''');
    SQL.Add(',Edittime=getdate() ');
    SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
    ExecSQL;
  end;
end;

procedure TfrmYSCR.ComboBox1Change(Sender: TObject);
begin
  TBRafresh.Click;
end;

procedure TfrmYSCR.ToolButton6Click(Sender: TObject);
begin
 frmCPXSCKList:=TfrmCPXSCKList.create(self) ;
  with frmCPXSCKList do
  begin
//    FfeeType:='坯布费用';
//    FCRType:='检验';
    show;
  end;
end;

procedure TfrmYSCR.v2PRTColorPropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  if Trim(CDS_HZ.FieldByName('YFType').AsString)='自动生成' then
  begin
    Application.MessageBox('自动生成的数据不能修改!','提示',0);
    Exit;
  end;
  try
    frmZDYHelp:=TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag:='P_color';
      flagname:='颜色';
      if ShowModal=1 then
      begin
        Self.CDS_HZ.Edit;
        Self.CDS_HZ.FieldByName('PRTColor').Value:=Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('UPdate YF_Money_CR ');
          sql.Add(' Set P_color='''+Trim(ClientDataSet1.fieldbyname('ZdyName').AsString)+'''');
          SQL.Add(',Editer='''+Trim(DName)+'''');
          SQL.Add(',Edittime=getdate()');
          SQL.Add(' where YFId='''+Trim(CDS_HZ.fieldbyname('YFId').AsString)+'''');
          ExecSQL;
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

end.
